program fcinst;

{ ** Konfiguriert den FileCommander  ** }
{ ** V. Pohlers 2023  ** }
{ end address 7fff }
const
  maxcount = 100;
  maxaddr = $00FF;
  patchfile = 'FCINST.TXT';
  version ='V0.2.1 16.6.2023';
  tab = #9;

type
  string60 = string[60];
  string20 = string[20];
  string2 = string[2];
  word = integer;

type
  patchline = record
    cond: word;
    addr: word;
    count: word;
    text: string60;
    default: string20;
  end;

var
  patchcount: integer;
  patches: array [1 .. maxcount] of patchline;
  ch: char;
  line: string[255];
  patchfield: array [0 .. maxaddr] of byte;

{ byte zu hex }
FUNCTION tohex(b: byte): string2;
CONST
  Hex: ARRAY [0 .. 15] OF char = '0123456789ABCDEF';
BEGIN
  tohex := Hex[b DIV 16] + Hex[b MOD 16];
END;

{ Ausgabe hex + ascii }
procedure writebyte(b: byte);
begin
  write(tohex(b), 'h');
  if (b > $20) and (b < $7F) then
    write(' [', chr(b), ']');
  write(' ');
end;

{ naechtes token aus string extrahieren }
function nextinput(var s:string60; trennz: char):string60;
var
  p: integer;
begin
  if s = '' then nextinput := ''
  else begin
    p := 1;
    while (s[p] = ' ') do p:=p+1; { fuehrende Leerzeichen }
    s:=copy(s,p,255);
    p := pos(trennz,s);
    if p > 0 then begin
        nextinput := copy(s,1,p-1);
        s := copy(s,p+1,255);
    end
     else begin
        nextinput := s;
        s := '';
     end;
  end;
end;

{ Zahl oder hexzahl oder 'a' Zeichen }
function getnumber(s: string60): word;
var
  w: word;
  error: integer;
begin
  if s='' then getnumber:=0
  else
  if s[1] = '''' then
  begin
    getnumber := ord(s[2]);
  end
  else
  begin
    if s[length(s)] = 'h' then
    begin
      s := copy(s, 1, length(s) - 1);
      val('$' + s, w, error);
    end
    else
    begin
      val(s, w, error);
    end;
    getnumber := w;
  end;
end;

{ Einlesen und Zerlegen der Patch-Datei }
{ ;Kommentarzeile, sonst 5 Felder, mit Tabulator getrennt }
{ bedingung     Adresse laenge  Beschreibung    aktueller Wert }
{ bedingung = 'const' - fester Wert' }
{ oder bedingung = addr. Wenn Inhalt <> 0, dann Patch zulaessig }

procedure ReadPatchFile;
var
  patchdata: text; { Patch-Datei }
  p2: integer;
  s1: string60;
  i: integer;
begin
  writeln('Lade ',patchfile);
	
  assign(patchdata, patchfile);
  reset(patchdata);

  patchcount := 0;
  while not eof(patchdata) do
  begin
    readln(patchdata, line);
    {writeln(line);}
    if not(line[1] = ';') then { keine Kommentarzeile }
    begin
      patchcount:=patchcount+1;
      if (line[1] = tab) then begin { keine Bedingung }
        p2 := 1;
        patches[patchcount].cond := 0;
      end
      else
      begin
        p2 := pos(tab, line);
        s1 := copy(line, 1, p2 - 1);
        { writeln('cond=', s1, '#'); {}
        if s1 = 'const' then
          patches[patchcount].cond := $FFFF
        else
          patches[patchcount].cond := getnumber(s1);
      end;
        line := copy(line, p2+1, 255);

        p2 := pos(tab, line);
        s1 := copy(line, 1, p2 - 1);
        line:=copy(line, p2+1, 255);
        { writeln('addr=', s1, '#'); {}
      patches[patchcount].addr := getnumber(s1);

        p2 := pos(tab, line);
        s1 := copy(line, 1, p2 - 1);
        line := copy(line, p2+1, 255);
        { writeln('length=', s1, '#'); {}
      patches[patchcount].count := getnumber(s1);

        p2 := pos(tab, line);
        s1 := copy(line, 1, p2 - 1);
        line := copy(line, p2+1, 255);
        { writeln('text=', s1, '#'); {}
      patches[patchcount].text := s1;

      s1 := line;
      { writeln('default=', s1, '#'); {}
      patches[patchcount].default := s1;
      patches[patchcount].text := patches[patchcount].text + ' [' + s1 + ']';
    end;
  end;
  Close(patchdata);
end;


{ daten aendern }
procedure ModifyData;
var
  i, j: integer;
  addr1: word;
  s, s1: string60;
begin
  writeln('Eingabe dezimal, hexadezimal mit h am Ende oder als Zeichen mit '' vor Zeichen');
  writeln('mehrere Werte durch Leerzeichen getrennt, z.B. "1 42h ''$"');
  writeln('Enter ohne Eingabe erhaelt den aktuellen Wert');
  writeln;
  for i := 1 to patchcount do
    if patches[i].cond = $FFFF then { const }
    begin
      for j := 0 to patches[i].count - 1 do
        patchfield[patches[i].addr + j] := ord(patches[i].default[j + 2]);
    end
    else if (patches[i].cond = 0) or (patchfield[patches[i].cond] <> 0) then
    begin
      write(i,'. '); 	
      writeln(patches[i].text);
      write('aktuell ');
      for j := 0 to patches[i].count - 1 do begin
        { writeln ('i=',i, ' addr=',patches[i].addr, ' j=',j,' value=',patchfield[patches[i].addr + j]); }
        writebyte(patchfield[patches[i].addr + j]);
      end;
      write('neu = ? ');
      readln(s);

      for j := 0 to patches[i].count - 1 do
      begin
        s1 := nextinput(s, ' ');
        if s1 <> '' then begin
          { writeln('Eingabe war ', s1, ' => ', getnumber(s1)); }
          patchfield[patches[i].addr + j] := getnumber(s1);
        end;
      end;
      writeln;
    end;
end;

{ patchfield anzeigen }
procedure Showpatchfield;
var
  i, j: integer;
begin
   for i := 0 to (maxaddr div 16) do begin
      write(tohex(i*16), ':');
      for j:= i*16 to i*16+15 do
      write(' ',tohex(patchfield[j]));
      writeln;
   end;
end;

{ ini laden }
procedure loadini;
var
  filename:string60;
  f: file;
begin
  write('Dateiname: ');readln(filename);
  assign(f,filename);
  {$I-}
  reset(f);
  {$I+}
  if ioresult<>0 then
    writeln('Datei nicht gefunden')
  else begin
    blockread(f,patchfield,1);
    close(f);
  end;
end;

{ ini speichern }
procedure saveini;
var
  filename:string60;
  f: file;
begin
  write('Dateiname: ');readln(filename);
  assign(f,filename);
  {$I-}
  rewrite(f);
  {$I+}
  if ioresult<>0 then
    writeln('Datei kann nicht geschrieben werden')
  else begin
    blockwrite(f,patchfield,1);
    close(f);
  end;
end;

procedure showpatches;
var
  i: integer;
begin
        for i := 1 to patchcount do
          writeln(i, '. ', 'cond=',patches[i].cond, ' addr=',patches[i].addr, ' text=', patches[i].text);
end;

procedure SetDefaultValues;
var
  i,j: integer;
  s1,s: string60;
begin
  for i := 1 to patchcount do
    if patches[i].cond = $FFFF then { const }
    begin
      for j := 0 to patches[i].count - 1 do
        patchfield[patches[i].addr + j] := ord(patches[i].default[j + 2]);
    end
    else
    begin
      s:=patches[i].default;
      for j := 0 to patches[i].count - 1 do begin
        s1 := nextinput(s, ',');
        { writeln('s=',s,' s1=',s1,' value=',getnumber(s1)); {}
        patchfield[patches[i].addr + j] := getnumber(s1);
      end;
    end;
end;

begin { MAIN }
  writeln('Patch Programm FileCommander');
  writeln('Version ',Version,' V.Pohlers');

  fillchar(patchfield,sizeof(patchfield),0);
  ReadPatchFile;
  SetDefaultValues;

  repeat
    writeln;
    { writeln('1 = Patch-Datei auflisten'); }
    writeln('L = INI-Datei laden');
    writeln('D = Bytes anzeigen');
    writeln('M = Daten aendern');
    writeln('S = INI-Datei schreiben');
    writeln('Q = Programm beenden');
    write('? ');
    readln(ch);
    ch := upcase(ch);
    case ch of
      '1': showpatches;
      'M': ModifyData;
      'D': Showpatchfield;
      'L': loadini;
      'S': saveini;
    end;
  until ch = 'Q';
end.
